import 'dart:async';

abstract class StreamManager<T> {
  StreamManager(T model) : _model = model;
  final StreamController<T> _streamController = StreamController<T>.broadcast();
  Stream<T> get stream => _streamController.stream;
  T _model;

  bool _isDirty;

  T get model => _model;
  set model(T newModel) {
    _model = newModel;
    _isDirty = true;
  }

  void update(T model) {
    _model = model;
    _isDirty = false;
    _streamController.sink.add(_model);
  }

  void dispose() {
    _streamController?.close();
  }
}